<script setup lang="ts">
import { useMemberStore } from '@/stores/member';
import { useReceiptStore } from '@/stores/receipt';
import type { Member } from '@/types/Member';
import { inject } from 'vue';
import { nextTick, ref } from 'vue';
import type { VForm } from 'vuetify/components';

const tel = ref('')
const cash = ref('')
const memberStore = useMemberStore()
const receiptStore = useReceiptStore()
const form = ref(false)
const refForm = ref<VForm | null>(null)
const dialog = ref(false)

function onClick() {
    memberStore.searchMember(tel.value)
    receiptStore.calReceipt()
}

const clearall = function () {
    memberStore.clear();
    tel.value = '';

};
const initialMember: Member = {
    id: -1,
    name: '',
    tel: '',
    point: 0
}
const editedMember = ref<Member>(JSON.parse(JSON.stringify(initialMember)))
const membership = memberStore.members
let editedIndex = -1
let lastId = memberStore.members.length + 1
function onSubmit() { }

function editItem(item: Member) {
    editedIndex = membership.indexOf(item)
    editedMember.value = Object.assign({}, item)
    dialog.value = true
}

function closeDialog() {
    dialog.value = false
    nextTick(() => {
        editedMember.value = Object.assign({}, initialMember)
        editedIndex = -1
    })
}

async function save() {

    if (editedIndex > -1) {
        Object.assign(membership[editedIndex], editedMember.value)
    } else {
        editedMember.value.id = lastId++
        memberStore.saveMember(editedMember.value)
    }

    closeDialog()
}

function but() {
    console.log(editedMember.value.name)
}
</script>

<template>
    <v-container>
        <v-row no-gutters>
            <v-col cols="6">
                <v-text-field v-model="tel" density="compact" variant="solo" label="Search" append-inner-icon="mdi-magnify"
                    single-line hide-details @click:append-inner="onClick" @keyup.enter="onClick"></v-text-field><br>
                <span v-if="memberStore.currentMember ? memberStore.currentMember?.name : ''">
                    <p style="font-size: 15pt;">
                        <v-icon style="color:#8B4513;">mdi-star-circle</v-icon>
                        <span style="color: #EC9B5B; "> {{ memberStore.currentMember ? memberStore.currentMember?.name : ''
                        }}</span>
                        <span style="color: #8B4513; "> point: </span>
                        <span style="color: rgb(0, 211, 7);"> {{ memberStore.currentMember ?
                            memberStore.currentMember?.point : '' }}</span>
                    </p>
                </span>
            </v-col>
            <v-col cols="6" class="pa-2 text-center">
                <div>

                    <v-row justify="center">
                        <v-dialog v-model="dialog" persistent width="1024">
                            <template v-slot:activator="{ props }">
                                <v-btn color="success" style="margin-right: 15px; margin-top: 6px;" v-bind="props">
                                    <v-icon>mdi-account</v-icon>
                                    Register Member
                                </v-btn>
                            </template>
                            <v-card>
                                <!-- <v-card-title>
                                    <span class="text-h5" style="color:Chocolate;">Register Member</span>
                                </v-card-title> -->
                                <v-card-text>
                                    <v-container>
                                        <v-row>
                                            <v-col cols="12" sm="6">
                                                <v-text-field label="Fullname*" v-model="editedMember.name"
                                                    required></v-text-field>
                                            </v-col>
                                            <v-col cols="12" sm="6">
                                                <v-text-field label="Tel*" required v-model="editedMember.tel"
                                                    :rules="[v => /^[0-9]{10}$/.test(v) || 'Please enter a valid phone number']"></v-text-field>
                                            </v-col>
                                        </v-row>
                                    </v-container>
                                    <small>*indicates required field</small>
                                </v-card-text>
                                <v-card-actions>
                                    <v-spacer></v-spacer>
                                    <v-btn color="blue-darken-1" variant="text" @click="closeDialog()">
                                        Close
                                    </v-btn>
                                    <v-btn color="blue-darken-1" variant="text" @click="save()">
                                        Save
                                    </v-btn>
                                </v-card-actions>
                            </v-card>
                        </v-dialog>
                    </v-row>
                </div>
            </v-col>
        </v-row>
        <v-row>
            <!-- <v-col cols="6">
                <v-text-field v-model="receiptStore.receipt.cash" density="compact" variant="solo" label="Cash" append-inner-icon="mdi-account-cash"
                    single-line hide-details @keyup.enter="onClick"></v-text-field>
            </v-col> -->
            <!-- <v-col cols="6" class="pa-2 text-center">
                <v-btn color="red" @click="clearall" style="margin-top: 5px;">
                    Clear
                </v-btn>
            </v-col> -->
        </v-row>
    </v-container>
</template>

<style scoped></style>